/* 
    grab - grab a picture into file pic.pnm (not very efficient yet!)

    Copyright (C) 1996,97 Ralph Metzler (rjkm@thp.uni-koeln.de)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <iostream.h>
#include <fstream.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
#include <sys/mman.h>
#include <fcntl.h>
#include <string.h>
#include "bttv.h"
#include "bt848.h"

struct bttv_window wtw;

int fwintv;
char *wintvname="/dev/bttv";

void main()
{
  int i, j;
  unchar *tm,c,r,g,b;

  if ((fwintv=open(wintvname,O_RDWR)) < 0) {
    printf("Cannot open %s\n", wintvname);
    exit(1);
  }
  
  ioctl(fwintv, BTTV_GETWTW, &wtw);
  wtw.y=0;
  wtw.bpp=3;
  wtw.bpl=768*wtw.bpp;
  wtw.width=768;
  wtw.height=576;
  wtw.swidth=768;
  wtw.sheight=576;
  wtw.norm=0;
  wtw.interlace=1;
  ioctl(fwintv, BTTV_SETWTW, &wtw);

  if (!(tm=(unchar *)malloc(0x200000)))  {
    printf("Cannot alloc memory\n");
    exit(1);
  }
  if (mlock(tm, 0x200000))
    exit(1);

  /* The memory is formally allocated and locked but not really there yet!
     Access one byte in each page (assumed to be 4096 Bytes) to really do it.
     */
  for (i=0; i<0x200000; i+=4096)
    tm[i]=1;
  // Just in case memory is not page aligned
  tm[0x1fffff]=1;

  //printf("tm: 0x%08x\n", (int) tm);
  ioctl(fwintv, BTTV_TESTM, &tm);
  close(fwintv);

  ofstream os("pic.pnm");
  os << "P6\n768\n576\n255\n";
  unchar *p=(unchar *) tm;
  for (i=0; i<768*576; i++, p+=3) {
    os.write((p+2),1);
    os.write((p+1),1);
    os.write(p,1);
  }
  os.close();

  munlock(tm, 0x200000);
  free(tm);
}

